/* 
Program byl napsan pro OEM verzi AXPERT 2424msxe (USB)
Odzkoušeno na RPI3 se systemem Raspbian
Kompilace: cc qpigs.c -o qpigs $(pkg-config --libs --cflags libusb-1.0)
1.2.2017 cz7jfm@mypower.cz
*/

#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <libusb.h>
#define SOUBOR "/tmp/QPIGS.log"										//Vystupní soubor s daty
#define SOUBOR1 "/tmp/QPIGS1.log"									//Zalozni vystupní soubor
#define SOUBOR2 "/home/cz7jfm/axpert/data.log"		//V pripade vypnuteho zarizeni zkopiruje se tento soubor do vystupniho souboru
int chyba=0;

libusb_device_handle *find_device (int vendor, int product) {
        libusb_device **list, *found = NULL;
        libusb_device_handle *handle = NULL;
        int err = 0;
        ssize_t cnt = libusb_get_device_list (NULL, &list);
				//printf("%i\n", cnt);
        if (cnt < 0) goto out;
        ssize_t i = 0;
        for (i = 0; i < cnt; i++) {
                struct libusb_device_descriptor desc;
                if (libusb_get_device_descriptor (list[i], &desc))
                        continue;
                if (desc.idVendor == vendor && desc.idProduct == product) {
                        found = list[i];
                        break;
                }
        }

        if (found)
					err = libusb_open (found, &handle);
        libusb_free_device_list (list, 1);
out:
        if (err != 0)
        	fprintf (stderr, "%s\n", libusb_error_name (err));
        return handle;
}

int main (int argc, char *argv[]) {
	int r=0;
	int len;
	libusb_init (NULL);
	libusb_device_handle *device = find_device (0x0665, 0x5161);
	if (!device) exit (EXIT_FAILURE);
	bool reattach_driver = false;
	if (libusb_kernel_driver_active (device, 0) == 1) {
		reattach_driver = true;
		libusb_detach_kernel_driver (device, 0);
	}
	libusb_claim_interface (device, 0);
	unsigned char data[8] = { 0x51, 0x50, 0x49, 0x47, 0x53, 0xB7, 0xA9, 0x0D };
	unsigned char qmod[8] = { 0x51, 0x4D, 0x4F, 0x44, 0x49, 0xC1, 0x0D, 0x00 };
	unsigned char data1[110];
	r = libusb_control_transfer (device, 0x21,0x09,0x0200,0x0000, data, sizeof data, 200);
	if(r < 0) chyba++;

	//printf("DATA: QPIGS\n");
	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[0]=data[1];
	data1[1]=data[2];
	data1[2]=data[3];
	data1[3]=data[4];
	data1[4]=data[5];
	data1[5]=data[6];
	data1[6]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[7]=data[0];
	data1[8]=data[1];
	data1[9]=data[2];
	data1[10]=data[3];
	data1[11]=data[4];
	data1[12]=data[5];
	data1[13]=data[6];
	data1[14]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[15]=data[0];
	data1[16]=data[1];
	data1[17]=data[2];
	data1[18]=data[3];
	data1[19]=data[4];
	data1[20]=data[5];
	data1[21]=data[6];
	data1[22]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[23]=data[0];
	data1[24]=data[1];
	data1[25]=data[2];
	data1[26]=data[3];
	data1[27]=data[4];
	data1[28]=data[5];
	data1[29]=data[6];
	data1[30]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[31]=data[0];
	data1[32]=data[1];
	data1[33]=data[2];
	data1[34]=data[3];
	data1[35]=data[4];
	data1[36]=data[5];
	data1[37]=data[6];
	data1[38]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[39]=data[0];
	data1[40]=data[1];
	data1[41]=data[2];
	data1[42]=data[3];
	data1[43]=data[4];
	data1[44]=data[5];
	data1[45]=data[6];
	data1[46]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[47]=data[0];
	data1[48]=data[1];
	data1[49]=data[2];
	data1[50]=data[3];
	data1[51]=data[4];
	data1[52]=data[5];
	data1[53]=data[6];
	data1[54]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[55]=data[0];
	data1[56]=data[1];
	data1[57]=data[2];
	data1[58]=data[3];
	data1[59]=data[4];
	data1[60]=data[5];
	data1[61]=data[6];
	data1[62]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[63]=data[0];
	data1[64]=data[1];
	data1[65]=data[2];
	data1[66]=data[3];
	data1[67]=data[4];
	data1[68]=data[5];
	data1[69]=data[6];
	data1[70]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[71]=data[0];
	data1[72]=data[1];
	data1[73]=data[2];
	data1[74]=data[3];
	data1[75]=data[4];
	data1[76]=data[5];
	data1[77]=data[6];
	data1[78]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[79]=data[0];
	data1[80]=data[1];
	data1[81]=data[2];
	data1[82]=data[3];
	data1[83]=data[4];
	data1[84]=data[5];
	data1[85]=data[6];
	data1[86]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[87]=data[0];
	data1[88]=data[1];
	data1[89]=data[2];
	data1[90]=data[3];
	data1[91]=data[4];
	data1[92]=data[5];
	data1[93]=data[6];
	data1[94]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[95]=data[0];
	data1[96]=data[1];
	data1[97]=data[2];
	data1[98]=data[3];
	data1[99]=data[4];
	data1[100]=data[5];
	data1[101]=data[6];
	data1[102]=data[7];
	if(r < 0) chyba++;

	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[103]=data[0];
	data1[104]=data[1];
	data1[105]=data[2];
	data1[106]=data[3];
	data1[107]=data[4];
	data1[108]=data[5];
	data1[109]=data[6];
	data1[110]=data[7];
	if(r < 0) chyba++;

	//dotaz na QMOD
	r = libusb_control_transfer (device, 0x21,0x09,0x0200,0x0000, qmod, sizeof qmod, 200);
	if(r < 0) chyba++;
	r = libusb_interrupt_transfer(device, 0x81, data, 8, &len, 200);
	data1[106] = ' ';
	data1[107]=data[1];
	if(r < 0) chyba++;

 if (chyba) {
	printf("%i\n", chyba);
	// chyba nebo timeout
	int libusb_reset_device	(libusb_device_handle * device)	;
	//printf("chyba, nebo timeout:\n");
		if (chyba > 14) {
		
		FILE *fr, *fw;
		unsigned char buf[120];
		size_t precteno, zapsano;
  
		fr = fopen(SOUBOR2, "rb");
		if (!fr) {
			fputs("Nemohu otevřít vstupní soubor.\n", stderr);
			return 1;
		}
		fw = fopen(SOUBOR1, "wb");
		if (!fw) {
			fclose(fr); 
			fputs("Nemohu otevřít výstupní soubor.\n", stderr);
			return 2;
		}
  
		while (precteno = fread(buf, 1, sizeof(buf), fr)) {
			zapsano = fwrite(buf, 1, precteno, fw);
			if (precteno > zapsano) {
				fputs("Chyba zápisu do souboru.\n", stderr);
				break;
			}
		}
		if (ferror(fr)) {
			fputs("Chyba čtení ze souboru.\n", stderr);
		}
		fclose(fr);
		fclose(fw);
		// kopie dat do zalozniho souboru --------------------------------
		fr = fopen(SOUBOR2, "rb");
		if (!fr) {
			fputs("Nemohu otevřít vstupní soubor.\n", stderr);
			return 1;
		}
		fw = fopen(SOUBOR, "wb");
		if (!fw) {
			fclose(fr); 
			fputs("Nemohu otevřít výstupní soubor.\n", stderr);
			return 2;
		}
		while (precteno = fread(buf, 1, sizeof(buf), fr)) {
			zapsano = fwrite(buf, 1, precteno, fw);
			if (precteno > zapsano) {
				fputs("Chyba zápisu do souboru.\n", stderr);
				break;
			}
		}
		if (ferror(fr)) {
			fputs("Chyba čtení ze souboru.\n", stderr);
		}
		fclose(fr);
		fclose(fw);
		}
		else
		{
			libusb_interrupt_transfer(device, 0x81, data1, 40, &len, 100);
		}
	}
	else
	{
		data1[108] = '\0';
		FILE *soubor;
		soubor = fopen(SOUBOR1, "w");
		fprintf(soubor, "%s", data1);
		fclose(soubor);
		// kopie dat do zalozniho souboru ------------------------
		soubor = fopen(SOUBOR, "w");
		fprintf(soubor, "%s", data1);
		fclose(soubor);
		//printf("%s\n",data1);
	}
	libusb_release_interface (device, 0);
	if (reattach_driver) libusb_attach_kernel_driver (device, 0);
	libusb_close (device);
	libusb_exit (NULL);
	return 0;
}
